package project.sichuan.shengzhongyiyuan2;

import com.ibatis.sqlmap.client.SqlMapClient;
import com.znshkj.mzyf.main.GlobalData;
import com.znshkj.mzyf.main.IbatisSqlMapClient;
import com.znshkj.mzyf.main.OutMsg;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import project.face.FReadOrder;

public class UploadKDrugTask extends FReadOrder implements Runnable {

   private boolean connState = false;
   private Connection hisCONN;
   SqlMapClient sqlMap = IbatisSqlMapClient.newInstence();


   public static void main(String[] args) {
      (new UploadKDrugTask()).run();
   }

   public boolean createSqlConn() {
      try {
         switch(getDbType()) {
         case 1:
            Class.forName("com.mysql.jdbc.Driver");
            if(GlobalData.getStatedbIP() == 1) {
               this.hisCONN = DriverManager.getConnection("jdbc:mysql://" + getDbIP() + ":3306/" + getDbName() + "?useUnicode=true&characterEncoding=utf8", getDbUserName(), getDbPWD());
            } else {
               this.hisCONN = DriverManager.getConnection("jdbc:mysql://" + getDbIP2() + ":3306/" + getDbName2() + "?useUnicode=true&characterEncoding=utf8", getDbUserName2(), getDbPWD2());
            }
            break;
         case 2:
            Class.forName("com.microsoft.jdbc.sqlserver.SQLServerDriver");
            if(GlobalData.getStatedbIP() == 1) {
               this.hisCONN = DriverManager.getConnection("jdbc:microsoft:sqlserver://" + getDbIP() + ":1433;DatabaseName=" + getDbName(), getDbUserName(), getDbPWD());
            } else {
               this.hisCONN = DriverManager.getConnection("jdbc:microsoft:sqlserver://" + getDbIP2() + ":1433;DatabaseName=" + getDbName2(), getDbUserName2(), getDbPWD2());
            }
            break;
         case 3:
            Class.forName("oracle.jdbc.driver.OracleDriver");
            if(GlobalData.getStatedbIP() == 1) {
               this.hisCONN = DriverManager.getConnection("jdbc:oracle:thin:@" + getDbIP() + ":1521:" + getDbName(), getDbUserName(), getDbPWD());
            } else {
               this.hisCONN = DriverManager.getConnection("jdbc:oracle:thin:@" + getDbIP2() + ":1521:" + getDbName2(), getDbUserName2(), getDbPWD2());
            }
            break;
         case 4:
            Class.forName("oracle.jdbc.driver.OracleDriver");
            if(GlobalData.getStatedbIP() == 1) {
               this.hisCONN = DriverManager.getConnection("jdbc:oracle:thin:@" + getDbIP() + ":1521/" + getDbName(), getDbUserName(), getDbPWD());
            } else {
               this.hisCONN = DriverManager.getConnection("jdbc:oracle:thin:@" + getDbIP2() + ":1521/" + getDbName2(), getDbUserName2(), getDbPWD2());
            }
         }

         OutMsg.println("标准：药品同步连接到HIS数据库的JDBC连接建立成功:" + this.hisCONN.toString());
         this.connState = true;
         return true;
      } catch (Exception var2) {
         OutMsg.println(var2);
         OutMsg.println("标准：药品同步连接HIS数据库失败！");
         this.connState = false;
         return false;
      }
   }

   public void run() {
      int i = 0;

      while(!this.connState && !this.createSqlConn()) {
         try {
            ++i;
            if(i > 100) {
               break;
            }

            Thread.sleep(2000L);
         } catch (InterruptedException var10) {
            var10.printStackTrace();
         }
      }

      if(this.connState) {
         Connection conn = null;

         try {
            OutMsg.println("标准：开始同步所有药品数据到设备出药目录!");
            conn = this.sqlMap.getDataSource().getConnection();
            PreparedStatement var18 = conn.prepareStatement("select drug_id,manufactory_id from drug_info");
            ResultSet var15 = var18.executeQuery();
            OutMsg.println("标准：开始清空原始设备出药目录!");
            PreparedStatement prst = this.hisCONN.prepareStatement("DELETE FROM HKC_DRUG_STORE");
            prst.execute();
            conn.commit();
            OutMsg.println("标准：清空原始设备出药目录完成！进行同步操作!");

            int num;
            for(num = 0; var15.next(); ++num) {
               prst = this.hisCONN.prepareStatement("insert into HKC_DRUG_STORE(pharmacy,drug_id,manufactory_id,state) values(?,?,?,?)");
               prst.setString(1, "21");
               prst.setString(2, var15.getString("drug_id"));
               prst.setString(3, var15.getString("manufactory_id"));
               prst.setString(4, "1");
               prst.execute();
               conn.commit();
               OutMsg.println("设备储存药品id：" + var15.getString("drug_id") + "，已完成信息同步。");
               prst.close();
            }

            var15.close();
            var18.close();
            conn.close();
            this.hisCONN.close();
            OutMsg.println("标准：药品数据同步完毕! 药品总数量：" + num);
         } catch (Exception var9) {
            OutMsg.println(var9);
            var9.printStackTrace();

            try {
               conn.close();
            } catch (SQLException var8) {
               var8.printStackTrace();
            }

            try {
               this.hisCONN.close();
            } catch (SQLException var7) {
               var7.printStackTrace();
            }

            OutMsg.println("标准：药品数据同步完毕!");
         }
      } else {
         OutMsg.println("标准：药品数据同步无法连接HIS数据库，退出!");
      }

   }
}
